
!UiTreeView methodsFor: 'initialization' stamp: 'mt 10/11/2010 15:13:54.92'!
initialize

	"Initialize headers."
	verticalHeader := Morph new color: Color transparent; width: self scrollBarThickness; changeTableLayout; listDirection: #topToBottom.
	horizontalHeader := Morph new color: Color transparent; height: self scrollBarThickness; changeTableLayout; listDirection: #leftToRight.
	vHeaderScroller := TransformMorph new color: Color transparent.
	hHeaderScroller := TransformMorph new color: Color transparent.

	super initialize.
	
	self
		borderWidth: 0;
		color: Color white.
	
	"Initialize viewport."
	self scroller addMorph: UiTreeViewport new.
	self connect: self viewport signal: #doubleClicked: toSelector: #toggleIndex:.
	self connect: self viewport signal: #decorationClicked: toSelector: #toggleIndex:.
	self viewport verticalHeader: verticalHeader.
	self viewport horizontalHeader: horizontalHeader.
	
	"Initialize item delegates."
	itemDelegates := Dictionary new.
	itemDelegates at: #default put: UiSimpleItemDelegate new.
	
	"Initialize headers - Finish."
	verticalHeader connect: self viewport signal: #resizedToWidth:height: toSelector: #height: pattern: #(2).
	vHeaderScroller addMorph: verticalHeader.

	horizontalHeader connect: self viewport signal: #resizedToWidth:height: toSelector: #width:.
	hHeaderScroller addMorph: horizontalHeader.

	self
		"addMorph: vHeaderScroller;"
		addMorph: hHeaderScroller.
	
	self resizeScroller.! !

!UiAbstractItemDelegate methodsFor: 'building' stamp: 'mt 10/7/2010 17:52:24.969'!
editorFor: aModelIndex

	self subclassResponsibility.! !

!UiSimpleItemDelegate methodsFor: 'building' stamp: 'mt 10/7/2010 17:57:23.422'!
editorFor: aModelIndex

	^ nil "no editor"! !

!UiTreeViewport methodsFor: 'accessing' stamp: 'mt 10/11/2010 14:08:18.971'!
currentCell: aPoint

	currentCell := aPoint.! !

!UiTreeViewport methodsFor: 'accessing' stamp: 'mt 10/11/2010 14:39:21.601'!
hoveredCell: aPoint

	hoveredCell := aPoint.
	self redrawLater.! !

!UiTreeViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 15:06:51.98'!
mouseDown: evt

	self currentCell: (self cellIndexFromPoint: evt position).
	self selection
		add: self currentCell
		event: evt.
	(self selection cells includes: self currentCell)
		ifFalse: [self currentCell: nil].

	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {#click:. #doubleClick:. nil. #startDrag:}
		threshold: 1. ! !

!UiViewColumnInfo methodsFor: 'geometry' stamp: 'mt 10/11/2010 16:39:30.146'!
optimalSize
	"Return the width of the largest item."
	
	| max |
	max := 0.
	items do: [:item | 
		item hResizing ~= #spaceFill
			ifTrue: [max := max max: (item width + (item valueOfProperty: #indent))]].
	max := max max: self headerItem submorphBounds width + 10.
	^ max! !
